import $ from 'jquery';

export default class Intersection {
	test() {
		return $('.jq_intersection').length ? true : false;
	}

	inView(items, self) {
		$.each(items, function(i, item) {
			if (item.isIntersecting || item.intersectionRatio > 0) {
				$(item.target).addClass('io-in-view');

				self.unobserve(item.target);
			}
		});
	}

	observe() {
		$('html').addClass('io-active');

		var $items = $('.jq_intersection');

		var viewport = new IntersectionObserver(this.inView, {
			threshold: .5
		});

		$items.each(function() {
			viewport.observe($(this)[0]);
		});
	}

	constructor() {
		if (this.test()) {
			if (!window.IntersectionObserver) {
				$.getScript(
					'//polyfill.io/v2/polyfill.min.js?features=IntersectionObserver',
					() => this.observe()
				);
			} else {
				this.observe();
			}
		}
	}
}