import $ from 'jquery';

import 'lazysizes';

import 'lazysizes/plugins/bgset/ls.bgset';

export default class Lazy {
	test() {
		return $('.lazyload').length ? true : false;
	}

	constructor() {
		if (this.test()) {
			document.addEventListener('lazybeforeunveil', function(e) {
				$(e.target)
					.filter('[data-bg]')
					.css('background-image', 'url(' + $(e.target).data('bg') + ')');
			});

			if (typeof window.lazySizesConfig !== 'undefined' && typeof $.mq !== 'undefined') {
				var customMedia = {};

				$.each($.mq.getBreakpoints(), function(rule, queries) {
					var mqIndex = queries.indexOf(' and ');

					if (mqIndex > 0) {
						customMedia['-' + rule + '-'] = queries;
						customMedia['--' + rule] = queries.slice(0, mqIndex);
						customMedia[rule + '--'] = queries.slice(mqIndex + 5);
					} else if (queries.indexOf('max-width') > 0) {
						customMedia[rule + '--'] = queries;
					} else {
						customMedia['--' + rule] = queries;
					}
				});

				if (!$.isEmptyObject(customMedia)) {
					window.lazySizesConfig.customMedia = customMedia;
				}

				window.lazySizes.init();
			} else {
				window.lazySizes.init();
			}
		}
	}
}